/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.stimmzettel.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.stimmzettel.entity.Stimmzettel;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class StimmzettelExtendedDAO extends AbstractStimmzettelDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: CountGebietAndStimmzettelteamNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT COUNT(o) FROM Stimmzettel o WHERE o.gebiet=?1 AND o.stimmzettelTeam = ?2<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountGebietAndStimmzettelteam( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByCountGebietAndStimmzettelteam" ,  gebiet ,  stimmzettelTeam  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountGebietAndStimmzettelteam(): Miss");
        }

        cache.put(key, super.findByCountGebietAndStimmzettelteam( gebiet ,  stimmzettelTeam  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountGebietAndStimmzettelteam(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountGebietAndStimmzettelteam( gebiet ,  stimmzettelTeam  );
}
/**
* Name: GebietAndStimmzettelteamNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet=?1 AND o.stimmzettelTeam = ?2<br>
* SQL: <br>
*/
@Override
public java.util.List<Stimmzettel> findByGebietAndStimmzettelteam( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.stimmzettel.entity.StimmzettelTeam stimmzettelTeam) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByGebietAndStimmzettelteam" ,  gebiet ,  stimmzettelTeam  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebietAndStimmzettelteam(): Miss");
        }

        cache.put(key, super.findByGebietAndStimmzettelteam( gebiet ,  stimmzettelTeam  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebietAndStimmzettelteam(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Stimmzettel>) cache.lookup(key));
    }

    return super.findByGebietAndStimmzettelteam( gebiet ,  stimmzettelTeam  );
}
/**
* Name: GebietCountNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT COUNT(o) FROM Stimmzettel o WHERE o.gebiet=?1<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByGebietCount( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByGebietCount" ,  gebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebietCount(): Miss");
        }

        cache.put(key, super.findByGebietCount( gebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebietCount(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByGebietCount( gebiet  );
}
/**
* Name: GebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Stimmzettel> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByGebiet" ,  gebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebiet(): Miss");
        }

        cache.put(key, super.findByGebiet( gebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebiet(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Stimmzettel>) cache.lookup(key));
    }

    return super.findByGebiet( gebiet  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Stimmzettel o WHERE o.gebiet.wahl=?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Stimmzettel> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Stimmzettel.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Stimmzettel>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
